<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"> <router-link to="/index">Dashboard</router-link> </li>
            <li class="breadcrumb-item active">Users</li>
        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-users'></i> Users<span class='fw-300'></span>
            </h1>
            <div v-if="findPermission('profile','createAny') || role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center mr-3">
                    <button class="btn btn-success" @click="openModal">
                        <i class="fas fa-user-plus"></i> Add User
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>

        <!-- Add Modal -->
        <div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle"><i class="fas fa-user-plus"></i> Add User</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group row">
                                    <label class="col-xl-12 form-label" for="firstName">Full name</label>
                                    <div class="col-6 pr-1">
                                        <input type="text" v-model="user.firstName" name="firstName" class="form-control" 
                                            :class="{ 'is-invalid': user.errors.has('firstName') }" id="firstName" 
                                            placeholder="First Name" value="" required>
                                        <has-error :form="user" field="firstName"></has-error>
                                    </div>
                                    <div class="col-6 pl-1">
                                        <input type="text" v-model="user.lastName" name="lastName" class="form-control" 
                                            :class="{ 'is-invalid': user.errors.has('lastName') }" id="lastName" 
                                            placeholder="Last Name" value="" required>
                                        <has-error :form="user" field="lastName"></has-error>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="form-label" for="username">Email</label> <span style="color:red;">*</span>
                                    <input type="email" v-model="user.username" name="username" class="form-control" 
                                        :class="{ 'is-invalid': user.errors.has('username') }" id="username" 
                                        placeholder="Enter your email" value="">
                                    <has-error :form="user" field="username"></has-error>
                                </div>
                                <div class="form-group">
                                    <label class="form-label" for="role">Role</label>
                                    <select v-model="user.role" name="role" class="form-control" 
                                        :class="{ 'is-invalid': user.errors.has('role') }" id="role">
                                        <option value="admin">Admin</option>
                                        <option value="user">User</option>
                                        <option v-for="role in roles" :key="role.id" :value="role">{{role.name}}</option>
                                    </select>
                                    <has-error :form="user" style="color:red;" field="role"></has-error>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <!-- gender -->
                                <div class="form-group">
                                    <label class="form-label" for="gender">Gender</label>
                                    <select v-model="user.gender" name="gender" class="form-control" 
                                        :class="{ 'is-invalid': user.errors.has('gender') }" id="gender">
                                        <option value="Male">Male</option>
                                        <option value="Female">Female</option>
                                    </select>
                                </div><!-- phone -->
                                <div class="form-group">
                                    <label class="form-label" for="phone">Phone number</label>
                                    <input type="text" v-model="user.phone" name="phone" class="form-control" 
                                        :class="{ 'is-invalid': user.errors.has('phone') }" id="phone" 
                                        placeholder="Phone number" value="" required>
                                    <has-error :form="user" field="phone"></has-error>
                                </div>
                                <!-- date of birth -->
                                <div class="form-group">
                                    <label class="form-label" for="dob">Date of birth</label>
                                    <input type="date" v-model="user.dob" name="dob" class="form-control text-muted" 
                                        :class="{ 'is-invalid': user.errors.has('dob') }" id="dob" 
                                        value="" required>
                                    <has-error :form="user" field="dob"></has-error>
                                </div>
                            </div>
                        </div>
                        <div class="form-group row mt-3">
                            <label class="col-xl-12 form-label" for="password">Password</label>
                            <div class="col-6 pr-1">
                                <input type="password" v-model="user.password" name="password" class="form-control" 
                                :class="{ 'is-invalid': user.errors.has('password') }" id="password" 
                                placeholder="Password" value="" required>
                            <has-error :form="user" field="password"></has-error>
                            </div>
                            <div class="col-6 pl-1">
                                <input type="password" v-model="user.confirm_password" name="confirm_password" class="form-control" 
                                :class="{ 'is-invalid': user.errors.has('confirm_password') }" id="confirm_password" 
                                placeholder="Confirm password" value="" required>
                            <has-error :form="user" field="confirm_password"></has-error>
                            </div>
                        </div>
                        <div class="row mt-4">
                            <div class="form-group text-left col-md-6">
                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox" class="custom-control-input" id="rememberme">
                                    <label class="custom-control-label" for="rememberme"> Terms of condition</label>
                                </div>
                            </div>
                            <div class="row no-gutters col-md-6">
                                <div class="col-lg-6 pl-lg-1 my-2">
                                    <button id="js-login-btn" class="btn btn-success btn-block" @click="addUser()"><i class="fas fa-user-plus"></i> Add</button>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="row text-center">
            <div class="row">
                <div class="col-xl-12 col-md-12">
                    <div id="panel-1" class="panel">
                        <div class="panel-hdr">
                            <h2>
                                User <span class="fw-300"><i>List</i></span>
                            </h2>
                            <div class="panel-toolbar">
                                <button class="btn btn-panel" data-action="panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></button>
                                <button class="btn btn-panel" data-action="panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></button>
                            </div>
                        </div>
                        <div class="panel-container show">
                            <div class="panel-content">
                                <!-- datatable start -->
                                <table id="dt-basic-example" class="table table-bordered table-hover w-100" style="width:100%">
                                    <thead>
                                        <tr>
                                            <th>S.N.</th>
                                            <th style="width:250px">Username</th>
                                            <th style="width:200px">Role</th>
                                            <th style="width:250px">Status</th>
                                            <th style="width:200px">Operations</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="(user,index) in users" :key="user.id">
                                            <td> {{index+1}} </td>
                                            <td><b> {{user.username}} </b> </td>
                                            <td> {{user.role}} </td>
                                            <td> 
                                                <button v-if="user.status=='Active'" type="button" style="width:100px" class="btn btn-success" disabled>{{user.status}} </button>
                                                <button v-if="user.status=='Inctive'" type="button" style="width:100px" class="btn btn-primary" disabled>{{user.status}} </button>
                                                <button v-if="user.status=='Deactive'" type="button" style="width:100px" class="btn btn-danger" disabled>{{user.status}} </button>
                                            </td>
                                            <td>
                                                <button @click="redirect(user._id)" type="button" class="btn btn-info">Show Detail</button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                                <!-- datatable end -->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
    export default {
        name: 'Users',
        data() {
            return {
                users:[],
                roles:[],
                user: new this.$Form ({
                    firstName:'',
                    lastName:'',
                    dob:'',
                    gender:'',
                    username: '',
                    password: '',
                    role: '',
                }),
                role:''
            }
        },
        methods: {
            fetchUsers() {
                this.$store.dispatch('user/all_user')
                .then(() => {
                    this.users = this.$store.getters['user/users']
                })
            },
            fetchRoles() {
                this.$store.dispatch('role/allRole')
                .then(() => {
                    this.roles = this.$store.getters['role/roles']
                })
            },
            redirect(id){
                this.$router.push(`/userDetail/${id}`)
            },
            openModal(){
                this.$$('#addModal').modal('show')
            },
            addUser() {
                if(this.user.password==this.user.confirm_password){
                    this.$store.dispatch('user/addUser', this.user)
                    .then(() => {
                        this.$$('#addModal').modal('hide')
                        this.fetchUsers()
                        this.$Toast.fire({
                            icon: 'success',
                            title: 'User added successfully'
                        })
                    })
                    .catch(()=>{
                        this.$Toast.fire({
                            icon: 'error',
                            title: 'Failed to add user'
                        })
                    })
                }
            },
            findPermission(resource,action){
                if(this.role!='user' && this.role!='admin'){
                    if(this.role.permissions.find(item => item.resource == resource && item.action == action)){
                        return true
                    }
                    else{
                        return false
                    }
                }
            }
        },
        created(){
            this.role = JSON.parse(localStorage.getItem("role"))
            this.fetchUsers()
            this.fetchRoles()
        }         
            
    }
</script>

<style scoped>

</style>
